#ifndef CONTEXT_CSD_LOOKUP_H_INCLUDED
#define CONTEXT_CSD_LOOKUP_H_INCLUDED 1

#include "bbdata.h"
#include "concretedata.h"
#include "context_uids.h"
#include "csd_presence.h"

const TTypeName KLookupType1 = { { CONTEXT_UID_SENSORDATAFACTORY }, 44, 1, 0 };
const TTypeName KLookupType = { { CONTEXT_UID_SENSORDATAFACTORY }, 44, 2, 0 };
_LIT(KLooker, "looker");
_LIT(KLooked, "looked");
_LIT(KWhen, "when");
_LIT(KLookup, "lookup");
_LIT(KTimeStamp, "timestamp");

class CBBLookup : public CBase, public TBBCompoundData {
public:
	TBBShortString		iLooker;
	TBBShortString		iLooked;
	TBBTime			iWhen;
	CBBPresence*		iPresence;
	TBBTime			iPresenceTimeStamp;

        IMPORT_C virtual const TTypeName& Type() const;
	IMPORT_C static const TTypeName& StaticType();

	IMPORT_C virtual TBool Equals(const MBBData* aRhs) const;

	IMPORT_C CBBLookup& operator=(const CBBLookup& aInfo);
	IMPORT_C MBBData* CloneL(const TDesC& Name) const;
	const MBBData* Part(TUint aPartNo) const;
	IMPORT_C static CBBLookup* NewL();
	IMPORT_C static CBBLookup* NewL(TUint aVersion);

	IMPORT_C ~CBBLookup();
	IMPORT_C bool operator==(const CBBLookup& aRhs) const;
	virtual const TDesC& StringSep(TUint aBeforePart) const;
	IMPORT_C virtual void InternalizeL(RReadStream& aStream);

private:
	IMPORT_C CBBLookup(TUint aVersion);
	IMPORT_C void ConstructL();
	TUint	iUseVersion, iCreatedVersion;
};

#endif
