#ifndef CONTEXT_CU_ERRORUI_H_INCLUDED
#define CONTEXT_CU_ERRORUI_H_INCLUDED 1

#include <aknview.h>
#include <bamdesca.h>


/*
 * Formats error information into rich text
 * First are shown the user-friendly texts for all errors,
 * then the technical info. If more than one error info node
 * exists, the user-friendly texts are repeated by the technical
 * ones for understandability
 */

IMPORT_C void ErrorIntoRichTextL(class CRichText& aInto, const class MErrorInfo& aFrom);

const TUid KErrorInfoView = { 0x1003 };
const TUid KStatusListView = { 0x1004 };

/*
 * not done yet -MR

class MStatusListObserver {
public:
	virtual void ItemsChanged() = 0;
	virtual void ItemsAdded() = 0;
	virtual void ItemsRemoved() = 0;
};

class MStatusList : public MDesCArray {
public:
	virtual const MErrorInfo* ErrorInfo(TInt aIndex) const = 0;
	virtual void SetObserver(MStatusListObserver* aObserver) = 0;
};

class CStatusListView : public CAknView {
public:
	IMPORT_C static CStatusListView* NewL();

	virtual void ShowWithData(MStatusList& aInfo) = 0;
};
*/

class CErrorInfoView : public CAknView {
public:
	IMPORT_C static CErrorInfoView* NewL();

	virtual void ShowWithData(const MErrorInfo& aInfo) = 0;
};

#endif
